]> git.wh0rd.org - home.git/blame - .bin/r
r: switch rb-all to git-rb-all
[home.git] / .bin / r
CommitLineData
35c220c5
MF
1#!/bin/bash
2g() { git "$@"; }
8f20a215 3err() { printf '%b\n' "$*" 1>&2; exit 1; }
e3be8889 4vr() { echo "$@"; "$@"; }
955eb9e8 5
24988ec0
MF
6case $1 in
7-x) set -x; shift;;
8esac
9
765bb138
MF
10case $1 in
11""|-*) ;;
17ff99a0
MF
12l)
13 cmd=list
14 shift
15 ;;
3c32f9b8
MF
16s)
17 cmd=sync
18 shift
19 ;;
dfe9b9cf
MF
20rb-all)
21 cmd=rebase
22 shift
23 set -- all "$@"
24 ;;
765bb138
MF
25*)
26 cmd=$1
27 shift
11233988 28 acmd=$(git config --get "alias.${cmd}" | sed 's: -.*::')
765bb138
MF
29 ;;
30esac
35c220c5 31
1400d2cd
MF
32mj_init() {
33 pipe=$(mktemp)
34 rm -f "${pipe}"
35 mkfifo "${pipe}"
36 exec {ctlfd}<>"${pipe}"
37 rm -f "${pipe}"
38 jobs=0
39 jobs_max=${1:-$(getconf _NPROCESSORS_ONLN)}
40}
41_mj_child() { echo ${BASHPID} $? >&${ctlfd} ; }
42mj_child() {
43 (
44 "$@"
45 _mj_child
46 ) &
47 mj_post_child
48}
49mj_post_child() {
50 : $(( ++jobs ))
51 if [[ ${jobs} -eq ${jobs_max} ]] ; then
52 read -r -u ${ctlfd} pid ret
53 : $(( --jobs ))
54 fi
55}
56mj_finish() {
57 wait
58}
59
60repo_root() {
61 local root=${PWD}
eee212f8 62 while [[ ! -d ${root}/.repo && ${root:-/} != "/" ]] ; do
1400d2cd
MF
63 root=${root%/*}
64 done
65 echo "${root}"
66}
67
003d4f70
MF
68process_reviewers() {
69 local r arr=()
70 for r in ${*//,/ } ; do
71 case ${r} in
a5f629de 72 OWNERS*|*/OWNERS*)
f8260dbd
MF
73 local owners=$(
74 awk -F'@' '
75 ($2 == "chromium.org" || $2 == "google.com") {list = list "," $1}
76 END {print substr(list, 2)}
77 ' "${r}"
78 )
003d4f70
MF
79 if [[ -z ${owners} ]] ; then
80 err "cannot find OWNERS list"
81 else
82 echo "Auto setting reviewers to: ${owners}"
83 fi
84 arr+=( ${owners} )
85 ;;
86 *)
87 arr+=( "${r}" )
88 ;;
89 esac
90 done
91 reviewers=$(printf '%s,' "${arr[@]}")
92 reviewers=${reviewers%,}
93}
94
b4533091
MF
95find_repo() {
96 # Diff projects have diff versions of repo. Find a compatible one.
97 local root=$(repo_root)
98
99 # Use the manifest repo URL.
100 local manifest_dir="${root}/.repo/manifests.git"
101 local d
102
103 # Default to the local repo if it's there.
104 local search=(
105 "${root}/.repo/repo"
106 )
107
108 case $(g --git-dir="${manifest_dir}" config remote.origin.url) in
109 *android*)
110 search+=(
111 /usr/local/src/repo
112 ~/src/repo
113 )
114 ;;
115 *chromium*|*chrome*)
116 search+=(
117 ~/depot_tools
118 ~/chromiumos/depot_tools
119 /usr/local/src/depot_tools
120 ~/src/depot_tools
121 )
122 ;;
123 esac
124 for d in "${search[@]}" ; do
125 if [[ -x ${d}/repo ]] ; then
126 echo "${d}"/repo
127 return
128 fi
129 done
130
131 # Fallback: use $PATH.
132 type -P repo
133}
134
955eb9e8 135case ${acmd:-${cmd}} in
35c220c5
MF
136rebase)
137 if [[ $1 == "all" ]] ; then
e947e1df 138 shift
e051dd74 139 if [[ $# -eq 0 ]] ; then
26580929 140 eval "$(bash-colors --env | sed 's:^:export :')"
1400d2cd
MF
141 root=$(repo_root)
142 mj_init
143 while read -a line ; do
144 dir=${line[0]}
145 proj=${line[2]}
24988ec0
MF
146 if ! cd "${root}/${dir}" ; then
147 echo "bad ${proj}"
148 continue
149 fi
1400d2cd 150 (
26580929 151 out=$(r rb all . 2>&1)
71b529c6 152 if [[ -n ${out} ]] ; then
26580929
MF
153 head=$(printf "%-40s" "${proj}")
154 echo "${out}" | sed "s:^:${head} :"
71b529c6 155 fi
1400d2cd
MF
156 _mj_child
157 ) &
158 mj_post_child
159 done < <(r l)
160 mj_finish
161 exit 0
162 #exec r forall -p -c 'r rb all .' </dev/null
e051dd74
MF
163 fi
164
26580929 165 exec git rb-all -q
35c220c5
MF
166 fi
167 ;;
7ba91d1a
MF
168clean)
169 root=$(repo_root)
170 cd "${root}" || exit 1
171 mj_init
172 while read -a line ; do
173 dir=${line[0]}
174 proj=${line[2]}
175 cd "${root}/${dir}"
176 (
177 out=$(g clean "$@" 2>&1)
178 if [[ -n ${out} ]] ; then
179 echo "### ${proj}"
180 echo "${out}"
181 fi
182 _mj_child
183 ) &
184 mj_post_child
185 done < <(r l)
186 mj_finish
187 exit
188 ;;
bf81de9c
MF
189sb)
190 sb_cmd=$1
191 case ${sb_cmd} in
192 pull) ;;
193 push) ;;
194 f|fetch) sb_cmd="fetch" ;;
195 *) err "unknown sandbox command: $1"
196 esac
197
955eb9e8
MF
198 sync_branch="v"
199
1400d2cd 200 root=$(repo_root)
955eb9e8
MF
201 cd "${root}" || exit 1
202
203 if [[ ! -e .repo/sandbox-url ]] ; then
8f20a215 204 err "Please configure remote url base in ${root}/.repo/sandbox-url"
955eb9e8
MF
205 fi
206 remote=$(<.repo/sandbox-url) || exit 1
207
208 echo "pushing projects from ${root}"
209
1400d2cd
MF
210 # ssh servers do not like it when you hammer them :)
211 # Received disconnect from 74.125.248.80: 7: Too many concurrent connections
212 # fatal: The remote end hung up unexpectedly
213 mj_init 16
b5092d38 214
7ba91d1a 215 rlist=$(r l)
955eb9e8
MF
216 tcnt=$(echo "${rlist}" | wc -l)
217 cnt=1
218 while read line ; do
219 line=( ${line} )
220 path=${line[0]}
221 export GIT_DIR=${path}/.git
222 proj=${line[2]}
223 printf '### (%*i/%i %3i%%) %s\n' \
224 ${#tcnt} $((cnt++)) ${tcnt} $(( cnt * 100 / tcnt )) ${proj}
225 src="${sync_branch}"
bf81de9c
MF
226 case ${sb_cmd} in
227 push)
228 g l -1 ${src} >& /dev/null || src=
229 mj_child g push --force ${remote}/${proj} ${src}:refs/sandbox/${USER}/${sync_branch} >/dev/null
230 ;;
231 pull)
232 ;;
233 fetch)
234 mj_child g fetch ${remote}/${proj} refs/sandbox/${USER}/${sync_branch}:refs/remotes/sb/${sync_branch} >/dev/null
235 ;;
236 esac
7ba91d1a 237 done < <(echo "${rlist}")
1400d2cd 238 mj_finish
955eb9e8
MF
239
240 exit 0
241 ;;
17ff99a0
MF
242g-push)
243 # For the times when repo is being stupid, push directly to gerrit myself.
e3be8889
MF
244 if ! branch=$(g symbolic-ref -q HEAD) ; then
245 err "could not figure out active branch"
246 fi
247 branch=${branch#refs/heads/}
248 if ! remote_branch=$(g cfg --get "branch.${branch}.merge") ; then
8e41af94
MF
249 echo "could not figure out remote branch; using ${branch}"
250 remote_branch=${branch}
e3be8889 251 fi
8a21037a
MF
252 if ! remote=$(g cfg --get "branch.${branch}.remote") ; then
253 for remote in cros-internal cros origin ; do
254 g cfg --get "remote.${remote}.url" >/dev/null && break
255 done
256 fi
d3bdab7a 257 review=$(g cfg --get "remote.${remote}.review")
e3be8889
MF
258 remote_branch=${remote_branch#refs/heads/}
259
eacd89fe 260 git_args=()
36fb4856
MF
261 reviewers=""
262 while [[ $# -gt 0 ]] ; do
263 case $1 in
264 --re)
003d4f70 265 process_reviewers "$2"
36fb4856
MF
266 shift
267 ;;
d8f836b5 268 -n|--dry-run|--draft)
eacd89fe
MF
269 git_args+=( $1 )
270 ;;
36fb4856
MF
271 *)
272 err "unknown option: $1"
273 ;;
274 esac
275 shift
276 done
277
d3bdab7a 278 ref_spec="${branch}:refs/for/${remote_branch}"
36fb4856
MF
279 if [[ -n ${reviewers} ]] ; then
280 reviewers=( ${reviewers//,/ } )
d3bdab7a
MF
281 if [[ ${review} != ssh://* ]] ; then
282 gob_args=$(printf 'r=%s,' "${reviewers[@]}")
283 ref_spec+="%${gob_args%,}"
284 else
285 git_args+=( "--receive-pack=git receive-pack ${reviewers[*]/#/--reviewer=}" )
286 fi
36fb4856
MF
287 fi
288
d3bdab7a 289 vr git push "${git_args[@]}" ${remote} ${ref_spec} && exit
e3be8889 290 err "could not figure out remote to push to"
17ff99a0 291 ;;
3c32f9b8 292sync)
35da3f7e 293 set -- -j16 -c "$@"
7dae893b 294 ;;
8f20a215
MF
295upload)
296 args=()
297 while [[ $# -gt 0 ]] ; do
298 case $1 in
299 --re)
003d4f70
MF
300 process_reviewers "$2"
301 args+=( --re "${reviewers}" )
302 shift 2
303 continue
8f20a215
MF
304 ;;
305 esac
306 args+=( "$1" )
307 shift
308 done
309 set -- "${args[@]}"
310 ;;
35da3f7e
MF
311email)
312 email=${1:-${USER}@chromium.org}
b4533091
MF
313
314 root=$(repo_root)
315 git --git-dir="${root}/.repo/manifests.git" cfg user.email "${email}"
316 git --git-dir="${root}/.repo/repo/.git" cfg user.email "${email}"
317
35da3f7e 318 cmd='forall'
b4533091 319 set -- -c "git cfg user.email '${email}'"
35da3f7e 320 ;;
35c220c5
MF
321esac
322
b4533091 323exec python2 $(find_repo) ${acmd:-${cmd}} "$@"